<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::mediaPlayer::UrlSource Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.4.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1media_player.html">mediaPlayer</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html">UrlSource</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1media_player_1_1_url_source-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::mediaPlayer::UrlSource Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_url_source_8h_source.html">UrlSource.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::mediaPlayer::UrlSource:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1media_player_1_1_url_source__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1media_player_1_1_url_source_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1media_player_1_1_url_source_inherit__map" id="alexa_client_s_d_k_1_1media_player_1_1_url_source_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1media_player_1_1_source_interface.html" title="alexaClientSDK::mediaPlayer\l::SourceInterface" alt="" coords="261,5,457,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html" title="alexaClientSDK::avsCommon\l::utils::RequiresShutdown" alt="" coords="5,5,202,44"/>
<area shape="rect" id="node4" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface.html" title="alexaClientSDK::avsCommon\l::utils::playlistParser\l::PlaylistParserObserverInterface" alt="" coords="250,68,467,120"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::mediaPlayer::UrlSource:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1media_player_1_1_url_source__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1media_player_1_1_url_source_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1media_player_1_1_url_source_coll__map" id="alexa_client_s_d_k_1_1media_player_1_1_url_source_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1media_player_1_1_source_interface.html" title="alexaClientSDK::mediaPlayer\l::SourceInterface" alt="" coords="261,5,457,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html" title="alexaClientSDK::avsCommon\l::utils::RequiresShutdown" alt="" coords="5,5,202,44"/>
<area shape="rect" id="node4" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface.html" title="alexaClientSDK::avsCommon\l::utils::playlistParser\l::PlaylistParserObserverInterface" alt="" coords="250,68,467,120"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a328034f6710afccd0bb4ca52bf648244"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html#a328034f6710afccd0bb4ca52bf648244">onPlaylistEntryParsed</a> (int requestId, std::string url, <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser.html#ab60fb31cb5497bc9f16feda4fc24fe8a">avsCommon::utils::playlistParser::PlaylistParseResult</a> parseResult, std::chrono::milliseconds duration=<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface.html#ab8960fc65f0ca81c3d0b41c13d5ffbcc">avsCommon::utils::playlistParser::PlaylistParserObserverInterface::INVALID_DURATION</a>) override</td></tr>
<tr class="separator:a328034f6710afccd0bb4ca52bf648244"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e89b94e63348690c5589946e452b9a5"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html#a6e89b94e63348690c5589946e452b9a5">hasAdditionalData</a> () override</td></tr>
<tr class="separator:a6e89b94e63348690c5589946e452b9a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ad648280a36f049de03bd98558d16db"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html#a8ad648280a36f049de03bd98558d16db">handleEndOfStream</a> () override</td></tr>
<tr class="separator:a8ad648280a36f049de03bd98558d16db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4620388e0fde7e7a9f7f03d24981f8a1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html#a4620388e0fde7e7a9f7f03d24981f8a1">preprocess</a> () override</td></tr>
<tr class="separator:a4620388e0fde7e7a9f7f03d24981f8a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">Overridden StreamSourceInterface methods.</div></td></tr>
<tr class="memitem:a300ab4708a8b1c9f2faa9f3dce2abc1d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html#a300ab4708a8b1c9f2faa9f3dce2abc1d">isPlaybackRemote</a> () const override</td></tr>
<tr class="separator:a300ab4708a8b1c9f2faa9f3dce2abc1d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">RequiresShutdown Functions</div></td></tr>
<tr class="memitem:a320f950cb606323dd89fa18b9398ed15"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html#a320f950cb606323dd89fa18b9398ed15">doShutdown</a> () override</td></tr>
<tr class="separator:a320f950cb606323dd89fa18b9398ed15"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1media_player_1_1_source_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1media_player_1_1_source_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_source_interface.html">alexaClientSDK::mediaPlayer::SourceInterface</a></td></tr>
<tr class="memitem:a64e705aab13326da47ab2110961bccfa inherit pub_methods_classalexa_client_s_d_k_1_1media_player_1_1_source_interface"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_source_interface.html#a64e705aab13326da47ab2110961bccfa">SourceInterface</a> (const std::string &amp;className)</td></tr>
<tr class="separator:a64e705aab13326da47ab2110961bccfa inherit pub_methods_classalexa_client_s_d_k_1_1media_player_1_1_source_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a95c787c015d44fb6409f0a050424cc0d inherit pub_methods_classalexa_client_s_d_k_1_1media_player_1_1_source_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_source_interface.html#a95c787c015d44fb6409f0a050424cc0d">~SourceInterface</a> ()=default</td></tr>
<tr class="separator:a95c787c015d44fb6409f0a050424cc0d inherit pub_methods_classalexa_client_s_d_k_1_1media_player_1_1_source_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">alexaClientSDK::avsCommon::utils::RequiresShutdown</a></td></tr>
<tr class="memitem:aae7174ed932ae1413460255238c4422b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#aae7174ed932ae1413460255238c4422b">RequiresShutdown</a> (const std::string &amp;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a>)</td></tr>
<tr class="separator:aae7174ed932ae1413460255238c4422b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a649b80d77e4e6f66e218ee3bfc71823b">~RequiresShutdown</a> ()</td></tr>
<tr class="memdesc:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a649b80d77e4e6f66e218ee3bfc71823b">More...</a><br /></td></tr>
<tr class="separator:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a745cd4dc404db52f7d0afbf838454fac inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a> () const</td></tr>
<tr class="separator:a745cd4dc404db52f7d0afbf838454fac inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a350a147e52eb3ad3c1326e6639861066 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown</a> ()</td></tr>
<tr class="separator:a350a147e52eb3ad3c1326e6639861066 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9352626109735aba40b5fb310913355 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#af9352626109735aba40b5fb310913355">isShutdown</a> () const</td></tr>
<tr class="separator:af9352626109735aba40b5fb310913355 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface.html">alexaClientSDK::avsCommon::utils::playlistParser::PlaylistParserObserverInterface</a></td></tr>
<tr class="memitem:a9930eca43e330858b3df227d78030e42 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface.html#a9930eca43e330858b3df227d78030e42">~PlaylistParserObserverInterface</a> ()=default</td></tr>
<tr class="separator:a9930eca43e330858b3df227d78030e42 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a1e496d33169a890c430142b6447ca077"><td class="memItemLeft" align="right" valign="top">static std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html">UrlSource</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html#a1e496d33169a890c430142b6447ca077">create</a> (<a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html">PipelineInterface</a> *pipeline, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_interface.html">avsCommon::utils::playlistParser::PlaylistParserInterface</a> &gt; playlistParser, const std::string &amp;url)</td></tr>
<tr class="separator:a1e496d33169a890c430142b6447ca077"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface')"><img src="closed.png" alt="-"/>&#160;Static Public Attributes inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface.html">alexaClientSDK::avsCommon::utils::playlistParser::PlaylistParserObserverInterface</a></td></tr>
<tr class="memitem:ab8960fc65f0ca81c3d0b41c13d5ffbcc inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface"><td class="memItemLeft" align="right" valign="top">static constexpr std::chrono::milliseconds&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface.html#ab8960fc65f0ca81c3d0b41c13d5ffbcc">INVALID_DURATION</a> = std::chrono::milliseconds(-1)</td></tr>
<tr class="memdesc:ab8960fc65f0ca81c3d0b41c13d5ffbcc inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">An invalid duration.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface.html#ab8960fc65f0ca81c3d0b41c13d5ffbcc">More...</a><br /></td></tr>
<tr class="separator:ab8960fc65f0ca81c3d0b41c13d5ffbcc inherit pub_static_attribs_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a1e496d33169a890c430142b6447ca077"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1e496d33169a890c430142b6447ca077">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html">UrlSource</a> &gt; alexaClientSDK::mediaPlayer::UrlSource::create </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html">PipelineInterface</a> *&#160;</td>
          <td class="paramname"><em>pipeline</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_interface.html">avsCommon::utils::playlistParser::PlaylistParserInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>playlistParser</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>url</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Creates an instance of the <code><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html">UrlSource</a></code> and installs the source within the GStreamer pipeline.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pipeline</td><td>The <code><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html">PipelineInterface</a></code> through which the source of the <code>AudioPipeline</code> may be set. </td></tr>
    <tr><td class="paramname"><a class="el" href="namespacealexa_client_s_d_k_1_1playlist_parser.html">playlistParser</a></td><td>The <code>PlaylistParserInterface</code> which will parse playlist urls. </td></tr>
    <tr><td class="paramname">url</td><td>The url from which to create the pipeline source from.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>An instance of the <code><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html">UrlSource</a></code> if successful else a <code>nullptr</code>. </dd></dl>

</div>
</div>
<a id="a320f950cb606323dd89fa18b9398ed15"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a320f950cb606323dd89fa18b9398ed15">&#9670;&nbsp;</a></span>doShutdown()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::mediaPlayer::UrlSource::doShutdown </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p></p>
<p>Prepares/enables this object to be deleted. This should be the last function called on this object prior to deleting (or resetting) its shared_ptr.</p>
<dl class="section warning"><dt>Warning</dt><dd><ul>
<li>Attempting to call functions on this object after calling <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown()</a> can result in undefined behavior. </li>
<li>Neglecting to call <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown()</a> on this object can result in resource leaks or other undefined behavior. </li>
</ul>
</dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a66df7916e28559f30233c2ff5a166293">alexaClientSDK::avsCommon::utils::RequiresShutdown</a>.</p>

</div>
</div>
<a id="a8ad648280a36f049de03bd98558d16db"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8ad648280a36f049de03bd98558d16db">&#9670;&nbsp;</a></span>handleEndOfStream()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::mediaPlayer::UrlSource::handleEndOfStream </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Internally, a source may need additional processing after EOS is reached. This function will process that data.</p>
<dl class="section return"><dt>Returns</dt><dd>A boolean indicating whether the process operation was successful. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_source_interface.html#a1db735cb93d89f68bcc07396cd90c849">alexaClientSDK::mediaPlayer::SourceInterface</a>.</p>

</div>
</div>
<a id="a6e89b94e63348690c5589946e452b9a5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6e89b94e63348690c5589946e452b9a5">&#9670;&nbsp;</a></span>hasAdditionalData()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::mediaPlayer::UrlSource::hasAdditionalData </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Internally, a source may have additional data after processing an EOS. This function indicates whether there is additional data, and should be called after <code><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_url_source.html#a8ad648280a36f049de03bd98558d16db">handleEndOfStream()</a></code>.</p>
<dl class="section return"><dt>Returns</dt><dd>A boolean indicating whether the source has additional data to be played. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_source_interface.html#a41ad7357d98f2efc7b520b33cbb9be4a">alexaClientSDK::mediaPlayer::SourceInterface</a>.</p>

</div>
</div>
<a id="a300ab4708a8b1c9f2faa9f3dce2abc1d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a300ab4708a8b1c9f2faa9f3dce2abc1d">&#9670;&nbsp;</a></span>isPlaybackRemote()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::mediaPlayer::UrlSource::isPlaybackRemote </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Indicates whether a source is local or remote from the perspective of the <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html">MediaPlayer</a> (e.g. playing out of the SDS is local, playing a URL is remote).</p>
<dl class="section return"><dt>Returns</dt><dd>A boolean indicating whether the source is from a remote or local source </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_source_interface.html#ab26b1c54c75a9e0f840e4a27670a66a6">alexaClientSDK::mediaPlayer::SourceInterface</a>.</p>

</div>
</div>
<a id="a328034f6710afccd0bb4ca52bf648244"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a328034f6710afccd0bb4ca52bf648244">&#9670;&nbsp;</a></span>onPlaylistEntryParsed()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::mediaPlayer::UrlSource::onPlaylistEntryParsed </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>requestId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>url</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser.html#ab60fb31cb5497bc9f16feda4fc24fe8a">avsCommon::utils::playlistParser::PlaylistParseResult</a>&#160;</td>
          <td class="paramname"><em>parseResult</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::chrono::milliseconds&#160;</td>
          <td class="paramname"><em>duration</em> = <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface.html#ab8960fc65f0ca81c3d0b41c13d5ffbcc">avsCommon::utils::playlistParser::PlaylistParserObserverInterface::INVALID_DURATION</a></code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Notification that an entry has been parsed.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">requestId</td><td>The id of the callback to connect this callback to an original request. </td></tr>
    <tr><td class="paramname">url</td><td>An entry that has been extracted. </td></tr>
    <tr><td class="paramname">parseResult</td><td>The result of parsing the playlist. </td></tr>
    <tr><td class="paramname">duration</td><td>A duration in milliseconds of the playlist entry, if it was able to be deduced based on available playlist metadata.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>This function is always called from a single thread in PlayListParser. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1playlist_parser_1_1_playlist_parser_observer_interface.html#a3b7892ff8f8f9a69dcbdb2ad3938182b">alexaClientSDK::avsCommon::utils::playlistParser::PlaylistParserObserverInterface</a>.</p>

</div>
</div>
<a id="a4620388e0fde7e7a9f7f03d24981f8a1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4620388e0fde7e7a9f7f03d24981f8a1">&#9670;&nbsp;</a></span>preprocess()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::mediaPlayer::UrlSource::preprocess </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<dl class="section note"><dt>Note</dt><dd>This function will block until the <code>onPlaylistParsed</code> callback. To avoid deadlock, callers must ensure that <code>preprocess</code> is not called on the same thread as the event loop handling <code>onPlaylistParsed</code>. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_source_interface.html#a1cd97cedd9cc6e8d1822f84bb74facf3">alexaClientSDK::mediaPlayer::SourceInterface</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/Users/sdy/AVS/github/avs-device-sdk/MediaPlayer/include/MediaPlayer/<a class="el" href="_url_source_8h_source.html">UrlSource.h</a></li>
<li>/Users/sdy/AVS/github/avs-device-sdk/MediaPlayer/src/<a class="el" href="_url_source_8cpp.html">UrlSource.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.4.0 - Copyright 2016-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
